{% raw %}

<div id="app" v-cloak class="paragraph-margin-bottom">

    <p class="chooser" style="font-weight:bold; font-size: 115%; background-color: #333b45;
    color: white;
    padding: 16px 24px;">
        Select a state: &nbsp; 
        <select v-model="currentState">
            <option v-for="(state, key) in states" v-bind:value="key">{{ state.name }}</option>
        </select>
    </p>

    <div v-show="!electionData" class="info"><p>Data is loading... Please wait.</p></div>

    <div v-if="electionData">

        <h3>Certified Presidential Election Results</h3>

        <div class="ve-table">
            <table class="ve-table-content ve-table-border-x">
                <thead class="ve-table-fixed-header ve-table-header">
                    <tr class="ve-table-header-tr">
                        <th class="ve-table-header-th">Candidate</th>
                        <th class="ve-table-header-th" colspan="2">Votes</th>
                    </tr>
                </thead>
                <tbody class="ve-table-body ve-table-row-hover ve-table-row-highlight">
                    <tr v-for="entry in president.candidates" class="ve-table-body-tr">
                        <td class="ve-table-body-td">
                            {{ entry.name_display }}
                        </td>
                        <td class="ve-table-body-td">
                            {{ entry.votes.niceFormat() }}
                        </td>
                        <td class="ve-table-body-td">
                            {{ entry.percent_display }}%
                        </td>
                    </tr>
                </tbody>
                <tfoot class="ve-table-fixed-footer ve-table-footer">
                    <tr class="ve-table-footer-tr" style="">
                        <td class="ve-table-footer-td">
                            Total
                        </td>
                        <td class="ve-table-footer-td">
                            {{ president.votes.niceFormat() }}
                        </td>
                        <td class="ve-table-footer-td">
                            
                        </td>
                    </tr>
                </tfoot>
            </table>
        </div>

        <h3>Ballot Counting Time-Series Chart</h3>

        <p>The following chart shows the progression of ballot counting for the Presidential race, beginning on November 3 and continuing over the following days. Some odd discrepencies appear in some states that deserve further investigation.You can compare multiple states by opening separate browser windows.</p>

        <div id="ChartContainer" class="ChartContainer paragraph-margin-bottom"></div>

        <table class="small">
            <tr>
                <th colspan="2">Legend</th>
            </tr>
            <tr>
                <th>Black</th>
                <td>Estimated percent of ballots counted (eevp)</td>
            </tr>
            <tr>
                <th>Green</th>
                <td>Total number of ballots counted</td>
            </tr>
            <tr>
                <th>Blue</th>
                <td>Percentage of votes for Democrats</td>
            </tr>
            <tr>
                <th>Red</th>
                <td>Percentage of votes for Republicans</td>
            </tr>
            <tr>
                <td colspan="2"><em>Thanks to <a href="http://understandingedison.us/">UnderstandingEdison.us</a> for developing this interactive chart.</em></td>
            </tr>
        </table>

        <p>It's expected that we would see high volatility in the red and blue lines at the start of the counts, and a smoothing effect towards the end. This is due to the fact that earlier batches of ballots have a greater impact on the cumulative margin than the later batches.</p>

        <p>Read <em><a href="/data/understanding-nyt-data/">Understanding the NYT Data</a></em> for more details on the low-quality data provided by NYT and common pitfalls.</p>

        <p>If you spot unusual anomalies, discuss them in the comments below.</p>

        <h3>Secondary Ballot Races</h3>

        <ve-table 
            v-bind:columns="[
                {field: 'race_name', key: 'a', title: 'Race', align: 'left'}, 
                {field: 'candidate_count', key: 'aa', title: 'Candidates', align: 'left'}, 
                {field: 'leader_party_id', key: 'b', title: 'Winning Party', align: 'left'},
                {field: 'vote_percent', key: 'c', title: 'Percent of Votes', align: 'left'},
                {field: 'winning_margin', key: 'cc', title: 'Winning Margin', align: 'left'},
                {field: 'total_votes', key: 'd', title: 'Total Votes', align: 'left'},
            ]" 
            v-bind:table-data="secondaryBallotRaces"
            v-bind:max-height="300"
        ></ve-table>

        <h3>Results by County</h3>

        <p><em>Coming soon.</em></p>

        <h3>Raw NYT Time-Series Data Files for {{ currentStateName }}</h3>

        <p>The following JSON data comes from the New York Times, and appears to be a transformed subset of the paid data stream from Edison Research, combined with a few entries from the Associated Press. The numbers for ballot batches are low-resolution in that they are only given in percentages and rounded to three decimal places (there's no exact ballot counts, except for the final result). If there are any instances where the data does not match the Secretary of State's final certified results, the SoS data should take priority.</p>

        <p>Read <em><a href="/data/understanding-nyt-data/">Understanding the NYT Data</a></em> for more information on common pitfalls.</p>

        <p>The NYT does <em>not</em> provide CSV files of the data, but you can generate CSV files below if you find these easier to work with. These contain only a core subset of the JSON data.</p>

        <p>We recommend the <a href="https://www.mozilla.org/en-GB/firefox/new/" target="_blank">Firefox browser</a> for exploring JSON data as it has a simple tree interface for drilling down into the data as well as keyword search. See example:</p>

        <p><img src="/images/json-firefox-example.gif" alt="" width="534" height="290" style="border: 1px solid #ccc"></p>

        <h4>Download</h4>

        <div class="ve-table responsive-table">
            <table class="ve-table-content ve-table-border-x">
                <thead class="ve-table-fixed-header ve-table-header">
                    <tr class="ve-table-header-tr">
                        <th class="ve-table-header-th">Type</th>
                        <th class="ve-table-header-th">Granularity</th>
                        <th class="ve-table-header-th">Includes timestamped batches</th>
                        <th class="ve-table-header-th">Download links</th>
                    </tr>
                </thead>
                <tbody class="ve-table-body ve-table-row-hover ve-table-row-highlight">
                    <tr class="ve-table-body-tr">
                        <td class="ve-table-body-td">
                            All Ballots
                        </td>
                        <td class="ve-table-body-td">
                            State Level
                        </td>
                        <td class="ve-table-body-td">
                            ✅
                        </td>
                        <td class="ve-table-body-td">
                            <a v-bind:href="'https://static01.nyt.com/elections-assets/2020/data/api/2020-11-03/state-page/' + currentState + '.json'">JSON&nbsp;Format</a>
                        </td>
                    </tr>
                    <tr class="ve-table-body-tr">
                        <td class="ve-table-body-td">
                            Presidential Ballots (by batch)
                        </td>
                        <td class="ve-table-body-td">
                            State Level
                        </td>
                        <td class="ve-table-body-td">
                            ✅
                        </td>
                        <td class="ve-table-body-td">
                            <a v-bind:href="'https://static01.nyt.com/elections-assets/2020/data/api/2020-11-03/race-page/' +  currentState + '/president.json'">JSON&nbsp;Format</a><br>                            
                            <a v-on:click.prevent="csvExport('presidential', 'raw')" href="#">Raw CSV Format</a> <br>
                            <a v-on:click.prevent="csvExport('presidential', 'enhanced')" href="#">Enhanced CSV Format</a> *
                        </td>
                    </tr>
                    <tr class="ve-table-body-tr">
                        <td class="ve-table-body-td">
                            Presidential Ballots
                        </td>
                        <td class="ve-table-body-td">
                           Precinct & County Level
                        </td>
                        <td class="ve-table-body-td">
                            ❌
                        </td>
                        <td class="ve-table-body-td">
                            <a v-bind:href="'https://static01.nyt.com/elections-assets/2020/data/api/2020-11-03/precincts/' +  states[currentState].abbr + 'General-latest.json'">JSON&nbsp;Format</a>
                            <br>
                            <a v-on:click.prevent="precinctCsvExport('raw')" href="#">Raw CSV Format</a> <br>
                        </td>
                    </tr>
                    <tr class="ve-table-body-tr">
                        <td class="ve-table-body-td">
                            Presidential Ballots
                            <br>"Concatenator" File
                        </td>
                        <td class="ve-table-body-td">
                            Precinct & County Level
                        </td>
                        <td class="ve-table-body-td">
                            ❌
                        </td>
                        <td class="ve-table-body-td">
                            <a v-bind:href="'https://static01.nyt.com/elections-assets/2020/data/api/2020-11-03/precincts/' +  states[currentState].abbr + 'GeneralConcatenator-latest.json'">JSON&nbsp;Format</a>
                            <br>
                            (This JSON file appears in a different structure and may include extra data. It appears to only be available for Florida, Michigan and Pennsylvania, for some reason.)
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>

    </div>

    <!--<ve-table 
        v-bind:columns="[{field: 'type', key: 'type', title: 'Type', align: 'left'}, {field: 'url', key: 'url', title: 'URL', align: 'left'}]" 
        v-bind:table-data="getRawDataLinks()"
    ></ve-table>-->

</div>

<p style="font-size: 85%">
    * In the enhanced Presidential ballot CSV files, the first 9 columns are the exact values as supplied by the NYT feed (as in the raw CSV), but the subsequent columns are some additional calculated values which are useful in seeing the changes (sometimes called deltas) between batches. Unfortunately the NYT percentages are rounded to the nearest 0.1%, and when extrapolating this out to hundreds of thousands of ballots, it can sometimes introduce anomalies in the calculations such as seeing more negative ballot numbers than is to be expected (yes, there are some strange negative values which may require investigation, but possibly not as many as you're seeing in the CSV). We're working on ways to normalize these, but in the meantime, be aware.
</p>

{% endraw %}